! @(#)ntt-verify.prg	14.1.1.1 (ESO-IPG) 09/16/99 10:00:31
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!  MIDAS procedure ntt-verify.prg  to execute the NTT observing batch test
!  procedures
!  K. Banse     950929
!
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++
! 
define/param p1 ? ? "enter ESO site - LaSilla or Garching:"
if p1(1:1) .eq. "G" then			!ESO - Garching
   define/local dira/c/1/60 "$MID_HOME/test/ntt "
   define/local dirb/c/1/60 "$MID_HOME/contrib/obs/ntt "
else if p1(1:1) .eq. "L" then			!ESO - La Silla
   define/local dira/c/1/60 "/refdata/batches "
   define/local dirb/c/1/60 "/diskb/midas/94NOV/contrib/proc "
else						!ESO - La Silla
   define/local dira/c/1/60 " " all
   define/local dirb/c/1/60 " " all
   inquire/keyw dira -
   "Enter directory for test image + verification procedures:"
   inquire/keyw dirb "Enter directory for observation batches:"
endif
! 
define/param p2 CURSOR ? -
             "Enter Cursor or Auto for interactive or automatic test:"
! 
if mid$sess(16:20) .eq. "94NOV" then
   $cp {dira}/star-id.prg star-id.prg
   $cp {dira}/load-test.prg load-test.prg
else
   set/midas path={dira}		!add test directory to proc_path
endif
! 
! 
!  get the observing batches to current directory
! 
$rm -f get_mode.prg point.prg seeing.prg tfocus.prg 
$rm -f obsinit.prg rotate.prg wfocus.prg
$cp {dirb}/obsinit.prg obsinit.prg
$cp {dirb}/wfocus.prg wfocus.prg
$cp {dirb}/tfocus.prg tfocus.prg
$cp {dirb}/seeing.prg seeing.prg
$cp {dirb}/get_mode.prg get_mode.prg
$cp {dirb}/point.prg point.prg
$cp {dirb}/rotate.prg rotate.prg
$chmod +w *.prg
! 
!  change @c get_mode to @@ get_mode
! 
$sed s/@c/@@/ seeing.prg > Null
$mv Null seeing.prg
$sed s/@c/@@/ point.prg > Null
$mv Null point.prg
$sed s/@c/@@/ rotate.prg > Null
$mv Null rotate.prg
! 
define/local mydir/c/1/80 " " all
mydir = m$symbol("MID_HOME") // "/test/ntt/"
intape/fits 1 midd {mydir}/red0045.mt >Null		!read FITS file
-rename midd0001.bdf red0045.bdf
! 
@@ load-test >Null			!load test image (avoid messages)
set/format i1
write/keyw rkey/r/1/20 0.0 all
write/keyw errsum/i/1/1 0
define/local loop/i/1/2 0,0
define/local refkey/r/1/21 0.0 all
! 
@@ obsinit				!initialize keywords
!
set/cursor 2 rectangle 100,100,110,111		!set 10x11 cursor rectangle
create/defaults center/gauss ? ? ? 2,1,3	!max. 3 cursor inputs
if p2(1:1) .eq. "A" then
   intape/fits 1 midd {mydir}/nttveria.mt >Null	!read 2 FITS tables
   -rename midd0001.tbl nttveria.tbl
   intape/fits 1 midd {mydir}/nttverib.mt >Null
   -rename midd0001.tbl nttverib.tbl
endif
! 
write/out "---------------"
write/out test the seeing
write/out "---------------"
write/out ">>> use the stars D, E and F for" the centering algorithm
if p2(1:1) .eq. "A" then
   select/table nttveria seq.gt.3.and.seq.lt.7 >Null
   @@ seeing p8=red0045,nttveria
else
   @@ seeing
endif
write/keyw rkey 1.059,1.184,0.039,0.044
@@ kcompare rkey outputr 1,4 0.005
! 
clear/chan over
@@ star-id
! 
write/out "--------------------"
write/out test the focus wedge
write/out "--------------------"
write/out ">>> use the stars A, B and C for" the centering algorithm
if p2(1:1) .eq. "A" then
   select/table nttveria seq.lt.4 >Null
   @@ wfocus p8=red0045,nttveria
else
   @@ wfocus
endif
write/keyw rkey -2.329,-244.60,0.114
@@ kcompare rkey outputr 1,3 0.005
! 
write/out 
write/out ">>> use the stars D, E and F for" the centering algorithm
if p2(1:1) .eq. "A" then
   select/table nttveria seq.gt.3.and.seq.lt.7 >Null
   @@ wfocus p8=red0045,nttveria
else
   @@ wfocus
endif
! 
write/keyw rkey -0.092,-9.692,0.005
@@ kcompare rkey outputr 1,3 0.005
clear/chan over
@@ star-id
create/defaults center/gauss ? ? ? 2,1,9	!max. 9 cursor inputs
! 
write/out "----------------------"
write/out test the through focus
write/out "----------------------"
write/out ">>> start at star B and follow up to the top to star H (9 centers)"
if p2(1:1) .eq. "A" then
   @@ tfocus -3.2 0.03 p8=red0045,nttverib >Null
else
   @@ tfocus -3.2 0.03
endif
write/keyw rkey -3.124,-2.97,-3.046,0.014,0.023
@@ kcompare rkey outputr 1,5 0.005
! 
create/defaults center/gauss ? ? ? 2,1,1	!max. 1 cursor inputs
! 
write/out "-----------------"
write/out test the pointing
write/out "-----------------"
! 
define/local angledef/i/1/5 0,35,145,-65,-125
define/local angle/i/1/1 0
write/keyw refkey 62.8,-24.43,-49.913,82.665,37.43,-56.03,6.528,96.345,-65.455
write/keyw refkey/r/10/10 -
-16.007,88.302,-39.086,48.68,46.59,-96.0147,-10.301,-16.007,65.4547,-39.086
refkey(20) = -88.301
! 
do loop = 1 5
   angle = angledef({loop})
   write/out ">>> use star B (rotator offset angle = {angle}"
   if p2(1:1) .eq. "A" then
      select/table nttveria seq.eq.2 >Null
      @@ point 1021.35 982 {angle} G p8=red0045,nttveria
      loop(2) = loop(1)*4-3
      rkey(1) = refkey({loop(2)}) 
      loop(2) = loop(2)+1
      rkey(2) = refkey({loop(2)}) 
      @@ kcompare rkey outputr 1,2 0.005
! 
      write/out 
      write/out ">>> use star C (rotator offset angle = {angle}"
      select/table nttveria seq.eq.3 >Null
      @@ point 1021.35 982 {angle} G p8=red0045,nttveria
      loop(2) = loop(2)+1
      rkey(1) = refkey({loop(2)}) 
      loop(2) = loop(2)+1
      rkey(2) = refkey({loop(2)}) 
      @@ kcompare rkey outputr 1,2 0.005
   else
      clear/chan over
      @@ star-id
      @@ point 1021.35 982 {angle} G
! 
      write/out 
      write/out ">>> use star C (rotator offset angle = {angle}"
      @@ point 1021.35 982 {angle} G
   endif
   write/out 
enddo
! 
create/defaults center/gauss ? ? ? 2,1,2	!max. 2 cursor inputs
!
write/out "-----------"
write/out test rotate
write/out "-----------"
define/local modedef/c*4/1/4 RILDREMDBLMDDIMD
define/local mode/c*4/1/1 "    "
! 
write/keyw refkey -
580.15,380.693,134.416,44.416,44.416,44.416,47.299,-42.7,47.299,-42.7
! 
do loop = 1 4
   mode = modedef({loop})
   clear/chan over
   @@ star-id
   write/out ">>> use star B and C (mode {mode})"
   if p2(1:1) .eq. "A" then
      select/table nttveria seq.ge.2.and.seq.le.3 >Null
      if mid$sess(16:20) .eq. "94NOV" then
         copy/table nttveria dummy
         @@ rotate G {mode} p8=red0045,dummy
      else
         @@ rotate G {mode} p8=red0045,nttveria
      endif
      rkey(1) = refkey(1)
      loop(2) = 2+loop(1)
      rkey(2) = refkey({loop(2)})
      @@ kcompare rkey outputr 1,2 0.005
   else
      @@ rotate G {mode}
   endif
   write/out 
enddo
! 
do loop = 1 2
   mode = modedef({loop})
   clear/chan over
   @@ star-id
   write/out ">>> use star G and B (mode {mode})"
   if p2(1:1) .eq. "A" then
      select/table nttveria seq.ge.7 >Null
      if mid$sess(16:20) .eq. "94NOV" then
         copy/table nttveria dummy
         @@ rotate G {mode} p8=red0045,dummy
      else
         @@ rotate G {mode} p8=red0045,nttveria
      endif
      rkey(1) = refkey(2)
      loop(2) = 6+loop(1)
      rkey(2) = refkey({loop(2)})
      @@ kcompare rkey outputr 1,2 0.005
   else
      @@ rotate G {mode}
   endif
   write/out 
enddo
! 
do loop = 1 2
   mode = modedef({loop})
   clear/chan over
   @@ star-id
   write/out ">>> use star B and G (mode {mode})"
   if p2(1:1) .eq. "A" then
      select/table nttveria seq.eq.2.or.seq.eq.7 >Null
      if mid$sess(16:20) .eq. "94NOV" then
         copy/table nttveria dummy
         @@ rotate G {mode} p8=red0045,dummy
      else
         @@ rotate G {mode} p8=red0045,nttveria
      endif
      rkey(1) = refkey(2)
      loop(2) = 8+loop(1)
      rkey(2) = refkey({loop(2)})
      @@ kcompare rkey outputr 1,2 0.005
   else
      @@ rotate G {mode}
   endif
   write/out 
enddo
!
! end of test
! 
if p2(1:1) .eq. "A" then		!in AUTO mode check for differences
   if errsum .gt. 0 then
      write/out 
      write/out We got problems, check the logfile...
      write/out
   else
      write/out 
      write/out All tests o.k.
      write/out
   endif
endif
! 
write/out
write/out >>> End of NTT verification suite <<<
write/out
